// VolumeControlDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VolumeControl.h"
#include "VolumeControlDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVolumeControlDlg dialog

CVolumeControlDlg::CVolumeControlDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVolumeControlDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVolumeControlDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVolumeControlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVolumeControlDlg)
	DDX_Control(pDX, IDC_CHECK2, m_RecMute);
	DDX_Control(pDX, IDC_CHECK1, m_PlayMute);
	DDX_Control(pDX, IDC_COMBO5, m_Rec);
	DDX_Control(pDX, IDC_COMBO4, m_Play);
	DDX_Control(pDX, IDC_COMBO3, m_MixerDevice);
	DDX_Control(pDX, IDC_COMBO2, m_SimplePlayback);
	DDX_Control(pDX, IDC_COMBO1, m_SimpleRecSource);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVolumeControlDlg, CDialog)
	//{{AFX_MSG_MAP(CVolumeControlDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	ON_CBN_SELCHANGE(IDC_COMBO2, OnSelchangeCombo2)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_CBN_SELCHANGE(IDC_COMBO3, OnSelchangeCombo3)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
	ON_BN_CLICKED(IDC_BUTTON8, OnButton8)
	ON_CBN_SELCHANGE(IDC_COMBO4, OnSelchangeCombo4)
	ON_CBN_SELCHANGE(IDC_COMBO5, OnSelchangeCombo5)
	ON_BN_CLICKED(IDC_BUTTON9, OnButton9)
	ON_BN_CLICKED(IDC_BUTTON10, OnButton10)
	ON_BN_CLICKED(IDC_BUTTON11, OnButton11)
	ON_BN_CLICKED(IDC_BUTTON12, OnButton12)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_BN_CLICKED(IDC_CHECK2, OnCheck2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVolumeControlDlg message handlers

BOOL CVolumeControlDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	VCInit();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVolumeControlDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVolumeControlDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CVolumeControlDlg::VCInit()
{
	m_VControl.CreateInstanceLic(__uuidof(vcproVolumeControlX), L"0");
	m_VControl2.CreateInstanceLic(__uuidof(vcproVolumeControlX), L"0");

	m_SimpleRecSource.AddString(_T("(0) Current"));
	m_SimpleRecSource.AddString(_T("(1) Microphone"));
	m_SimpleRecSource.AddString(_T("(2) CD Audio"));
	m_SimpleRecSource.AddString(_T("(3) Line In"));
	m_SimpleRecSource.AddString(_T("(4) Aux"));
	m_SimpleRecSource.AddString(_T("(5) Phone Line"));
	m_SimpleRecSource.SetCurSel(0);
	OnSelchangeCombo1();
	
	m_SimplePlayback.AddString(_T("(0) Total"));
	m_SimplePlayback.AddString(_T("(1) Microphone"));
	m_SimplePlayback.AddString(_T("(2) CD Audio"));
	m_SimplePlayback.AddString(_T("(3) Line In"));
	m_SimplePlayback.AddString(_T("(4) Aux"));
	m_SimplePlayback.AddString(_T("(5) Phone Line"));
	m_SimplePlayback.AddString(_T("(6) Wave"));
	m_SimplePlayback.AddString(_T("(7) Wave Table"));
	m_SimplePlayback.SetCurSel(0);
	OnSelchangeCombo2();

	for (int i = 0; i <= m_VControl2->GetMixerCount() - 1; i++)
	{
		m_VControl2->SelectMixer(i);
		m_MixerDevice.AddString(m_VControl2->GetMixerName());
	}
	m_MixerDevice.SetCurSel(0);
	OnSelchangeCombo3();

	UpdateData(false);
}

void CVolumeControlDlg::VCUninit()
{
	//
}

void CVolumeControlDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	VCUninit();	
	CDialog::OnClose();
}

// simple

int CVolumeControlDlg::getSimpleRecVolume() { return m_VControl->GetRecVolume(); }

int CVolumeControlDlg::getSimplePlayVolume()
{
	return m_VControl->GetPlayVolume(static_cast<vcPlayDest>(m_SimplePlayback.GetCurSel()));
}

void CVolumeControlDlg::setSimpleRecVolume(int value)
{
	m_VControl->SetRecVolume(value);
	updateRecVolume();
}

void CVolumeControlDlg::setSimplePlayVolume(int value)
{
	m_VControl->SetPlayVolume(static_cast<vcPlayDest>(m_SimplePlayback.GetCurSel()), value);
	updatePlayVolume();
}

void CVolumeControlDlg::updateRecVolume()
{
	CWnd* pWnd = GetDlgItem(IDC_STATIC1);
	pWnd->SetWindowText(INT2STR(getSimpleRecVolume()));
}

void CVolumeControlDlg::updatePlayVolume()
{
	CWnd* pWnd = GetDlgItem(IDC_STATIC2);
	pWnd->SetWindowText(INT2STR(getSimplePlayVolume()));
}

void CVolumeControlDlg::OnSelchangeCombo1() 
{
	m_VControl->RecSource = static_cast<vcRecSource>(m_SimpleRecSource.GetCurSel());
	updateRecVolume();
}

void CVolumeControlDlg::OnSelchangeCombo2() { updatePlayVolume(); }

void CVolumeControlDlg::OnButton1() { setSimpleRecVolume(getSimpleRecVolume() - 1); }

void CVolumeControlDlg::OnButton2() { setSimpleRecVolume(getSimpleRecVolume() + 1); }

void CVolumeControlDlg::OnButton3() { setSimplePlayVolume(getSimplePlayVolume() - 1); }

void CVolumeControlDlg::OnButton4() { setSimplePlayVolume(getSimplePlayVolume() + 1); }

// full

int CVolumeControlDlg::getRecLineVolume() { return m_VControl2->GetVolume(recIndex, -1); }

int CVolumeControlDlg::getPlayLineVolume() { return m_VControl2->GetVolume(playIndex, -1); }

void CVolumeControlDlg::setRecLineVolume(int value)
{
	m_VControl2->SetVolume(recIndex, -1, value);
	updateRecLine();
}

void CVolumeControlDlg::setPlayLineVolume(int value)
{
	m_VControl2->SetVolume(playIndex, -1, value);
	updatePlayLine();
}

void CVolumeControlDlg::updateRecLine()
{
	CWnd* pWnd = GetDlgItem(IDC_STATIC5);
	pWnd->SetWindowText(INT2STR(getRecLineVolume()));
}

void CVolumeControlDlg::updatePlayLine()
{
	CWnd* pWnd = GetDlgItem(IDC_STATIC3);
	pWnd->SetWindowText(INT2STR(getPlayLineVolume()));
}

void CVolumeControlDlg::OnSelchangeCombo3() 
{
   m_VControl->DeviceId = m_MixerDevice.GetCurSel();
   m_SimpleRecSource.SetCurSel(0);
	OnSelchangeCombo1();
   m_SimplePlayback.SetCurSel(0);
	OnSelchangeCombo2();

   m_VControl2->SelectMixer(m_MixerDevice.GetCurSel());
    
   playIndex = m_VControl2->GetLineIndex(true);
   recIndex = m_VControl2->GetLineIndex(false);

	updateRecLine();
	updatePlayLine();
    
   m_Play.ResetContent();
	for (int i = 0; i <= m_VControl2->GetLineConnectionCount(playIndex) - 1; i++)
        m_Play.AddString(m_VControl2->GetLineConnectionName(playIndex, i, false));
   if (m_Play.GetCount() != 0) m_Play.SetCurSel(0);
	OnSelchangeCombo4();
    
   m_Rec.ResetContent();
	for (i = 0; i <= m_VControl2->GetLineConnectionCount(recIndex) - 1; i++)
        m_Rec.AddString(m_VControl2->GetLineConnectionName(recIndex, i, false));

   if (m_Rec.GetCount() != 0) m_Rec.SetCurSel(m_VControl2->GetRecSource());
	OnSelchangeCombo5();
}

void CVolumeControlDlg::OnButton5() { setPlayLineVolume(getPlayLineVolume() - 1); }

void CVolumeControlDlg::OnButton6() { setPlayLineVolume(getPlayLineVolume() + 1); }

void CVolumeControlDlg::OnButton7() { setRecLineVolume(getRecLineVolume() - 1); }

void CVolumeControlDlg::OnButton8() { setRecLineVolume(getRecLineVolume() + 1); }

int CVolumeControlDlg::getRecConnVolume()
{
	return m_VControl2->GetVolume(recIndex, m_Rec.GetCurSel());
}

int CVolumeControlDlg::getPlayConnVolume()
{
	return m_VControl2->GetVolume(playIndex, m_Play.GetCurSel());
}

void CVolumeControlDlg::setRecConnVolume(int value)
{
	m_VControl2->SetVolume(recIndex, m_Rec.GetCurSel(), value);
	updateRecConn();
}

void CVolumeControlDlg::setPlayConnVolume(int value)
{
	m_VControl2->SetVolume(playIndex, m_Play.GetCurSel(), value);
	updatePlayConn();
}

void CVolumeControlDlg::updateRecConn()
{
	CWnd* pWnd = GetDlgItem(IDC_STATIC8);
	pWnd->SetWindowText(INT2STR(getRecConnVolume()));
}

void CVolumeControlDlg::updatePlayConn()
{
	CWnd* pWnd = GetDlgItem(IDC_STATIC7);
	pWnd->SetWindowText(INT2STR(getPlayConnVolume()));
}

void CVolumeControlDlg::OnSelchangeCombo4()
{
	updatePlayConn();
	updatePlayMuted();
}

void CVolumeControlDlg::OnSelchangeCombo5()
{
	m_VControl2->SetRecSource(m_Rec.GetCurSel(), true);
	updateRecConn();
	updateRecMuted();
}

void CVolumeControlDlg::OnButton9() { setPlayConnVolume(getPlayConnVolume() - 1); }

void CVolumeControlDlg::OnButton10() { setPlayConnVolume(getPlayConnVolume() + 1); }

void CVolumeControlDlg::OnButton11() { setRecConnVolume(getRecConnVolume() - 1); }

void CVolumeControlDlg::OnButton12()  { setRecConnVolume(getRecConnVolume() + 1); }

void CVolumeControlDlg::updateRecMuted()
{
	m_RecMute.SetCheck(false);
	bool enabled = m_VControl2->GetMuteControlId(recIndex, m_Rec.GetCurSel()) >= 0;
	m_RecMute.EnableWindow(enabled);
    if (enabled)
		m_RecMute.SetCheck(m_VControl2->IsMutedConnection(recIndex, m_Rec.GetCurSel()));
}

void CVolumeControlDlg::updatePlayMuted()
{
	int check = m_VControl2->IsMutedConnection(playIndex, m_Play.GetCurSel()) ? 1 : 0;
	m_PlayMute.SetCheck(check);
}

void CVolumeControlDlg::OnCheck1() 
{
	m_VControl2->MuteConnection(playIndex, m_Play.GetCurSel(), m_PlayMute.GetCheck() == 1);
}

void CVolumeControlDlg::OnCheck2() 
{
	m_VControl2->MuteConnection(recIndex, m_Rec.GetCurSel(), m_RecMute.GetCheck() == 1);
}
